Models/Photo.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace TooJaVile.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations; //lisasin selle osa

    public partial class Photo
    {
        public int Id { get; set; }
        public int AlbumId { get; set; }
        public int PictureId { get; set; }
        [DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:dd.MM.yyyy}")] //Created aja vorming
        public System.DateTime Created { get; set; }
    
        public virtual DataFile DataFile { get; set; }
        public virtual Album Album { get; set; }
    }
}

Controllers/MyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using TooJaVile.Models;

namespace TooJaVile.Controllers
{
    public class MyController : Controller
    {
        TooJaVileEntities db = new TooJaVileEntities();
        [OutputCache(Duration = 3600, VaryByParam = "id", Location = System.Web.UI.OutputCacheLocation.Any)]
        public ActionResult Content(int? id)
        {
            DataFile df = db.DataFiles.Find(id);
            if (df == null) return HttpNotFound();
            return File(df.Content, df.ContentType);
        }

        //meie veel ei oska checkperson teha
        protected Person CurrentPerson = null; // siis on hea kohe see PersonObject omale taskusse panna
        protected void CheckPerson()
        {
            if (Request.IsAuthenticated)        // kontrollida vaja vaid siis
                if ((CurrentPerson?.Email ?? "") != User.Identity.Name)    // kui juba ei ole meeles või on vale
                {
                    CurrentPerson = db.People.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                    if (CurrentPerson == null)


                    {
                        using (ApplicationDbContext dba = new ApplicationDbContext())
                        {
                            ApplicationUser u = dba.Users.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                            db.People.Add(CurrentPerson = new Person
                            {
                                Email = User.Identity.Name,
                                FirstName = u.FirstName,
                                LastName = u.LastName,
                                BirthDate = u.BirthDate
                            });
                            db.SaveChanges();
                        }
                    }
                }
                else CurrentPerson = null;
        }

        protected void ChangeDataFile(HttpPostedFileBase file, Action<int> change, int? oldId)
        {
            if (file != null && file.ContentLength > 0)
                using (BinaryReader br = new BinaryReader(file.InputStream))
                {
                    DataFile df = new DataFile
                    {
                        Content = br.ReadBytes(file.ContentLength),
                        FileName = file.FileName.Split('\\').Last().Split('/').Last(),
                        ContentType = file.ContentType,
                        Created = DateTime.Now
                    };
                    db.DataFiles.Add(df);
                    db.SaveChanges();
                    change(df.Id);
                    if (oldId.HasValue)
                    {
                        db.DataFiles.Remove(db.DataFiles.Find(oldId.Value));
                        db.SaveChanges();
                    }

                }
        }


    }

    public class HomeController : MyController
    {
        public ActionResult Index()
        {
            //CheckPerson();
            return View();
        }
        public ActionResult About()
        {
            ViewBag.Message = "Puhkuste kalender"; //muutsin nime KL

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Puhkuste jäägid"; //muutsin nime KL

            return View();
        }
    }
}

Controllers/PhotosController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using TooJaVile.Models;
using System.IO;

namespace TooJaVile.Controllers
{
    [Authorize]
    public class PhotosController : MyController
    {
        private TooJaVileEntities db = new TooJaVileEntities();

        // GET: Photos
        public ActionResult Index(int id = 0)
        {





            
            var photos = db.Photos.Include(p => p.DataFile).Include(p => p.Album)
                .Where(x => id == 0 || id == (x.AlbumId)); //lisasin, et leiaks albumvaates albumi nime järgi

            ViewBag.Ret = id;
            ViewBag.AlbumName = db.Albums.Find(id)?.Name ?? "";
            return View(photos.ToList());
        }

        // GET: Photos/Details/5
        public ActionResult Details(int? id, int ret = 0)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Photo photo = db.Photos.Find(id);
            if (photo == null)
            {
                return HttpNotFound();
            }
            ViewBag.Ret = ret;
            return View(photo);
        }

        // GET: Photos/Create
        public ActionResult Create(int id = 0)
        {
            ViewBag.Ret = id;
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType");
            ViewBag.AlbumId = new SelectList(db.Albums, "Id", "Name");
            return View(new Photo { Created = DateTime.Now, PictureId = 0});
        }

        // POST: Photos/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,AlbumId,PictureId,Created")] Photo photo, HttpPostedFileBase file, int ret = 0)
        {
            if (ModelState.IsValid)
            {

                //siin ees ei ole db.Photos.Add(photo); ja db.SaveChanges();  kna pilt on kohustuslik ja ei saa enne salvestada, kui ta ei ole pilti lugenud. 
                //seetõttu on siin need asjad if-i sees, 

                //siia pildiga toimetamine
                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();                      
                        photo.PictureId = df.Id;
                        db.SaveChanges();
                        db.Photos.Add(photo);
                        db.SaveChanges();
                    }


                //siin lõpeb toimetamine pildiga
                return ret == 0
                    ? RedirectToAction("Index")
                    : RedirectToAction("Details", "Albums", new { id = ret })
                    ;
            }


            ViewBag.Ret = ret;
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", photo.PictureId);
            ViewBag.AlbumId = new SelectList(db.Albums, "Id", "Name", photo.AlbumId);
            return View(photo);
        }

        // GET: Photos/Edit/5
        public ActionResult Edit(int? id, int ret = 0)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Photo photo = db.Photos.Find(id);
            if (photo == null)
            {
                return HttpNotFound();
            }
            ViewBag.Ret = ret;
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", photo.PictureId);
            ViewBag.AlbumId = new SelectList(db.Albums, "Id", "Name", photo.AlbumId);
            return View(photo);
        }

        // POST: Photos/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,AlbumId,PictureId,Created")] Photo photo, HttpPostedFileBase file, int ret = 0)
        {
            if (ModelState.IsValid)
            {
                db.Entry(photo).State = EntityState.Modified;
                db.Entry(photo).Property("PictureId").IsModified = false; //lisasin selle juurde, muidu kustub pilt ära
                db.SaveChanges();


                ChangeDataFile(
                               file,
                               x => { photo.PictureId = x; db.SaveChanges(); },
                                photo.PictureId);



                //siia pildiga toimetamine
                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        //selleks et vana pilt kustutada, jätame meelde pildi numbri
                        int? vanaPiltId = photo.PictureId;
                        photo.PictureId = df.Id;
                        db.SaveChanges();
                        //siin ei tohi vana pilti ära kustutada, sest meil on mitmes kohas sama pilt
                        //if (vanaPiltId.HasValue)
                        //{
                        //    db.DataFiles.Remove(db.DataFiles.Find(vanaPiltId.Value));
                        //    db.SaveChanges();
                        //}
                    }

                //siin lõpeb toimetamine pildiga




                return ret == 0 
                    ? RedirectToAction("Index")
                    : RedirectToAction("Details", "Albums", new { id = ret})
                    ;
            }
            ViewBag.Ret = ret;
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", photo.PictureId);
            ViewBag.AlbumId = new SelectList(db.Albums, "Id", "Name", photo.AlbumId);
            return View(photo);
        }

        // GET: Photos/Delete/5
        public ActionResult Delete(int? id, int ret = 0)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Photo photo = db.Photos.Find(id);
            if (photo == null)
            {
                return HttpNotFound();
            }
            ViewBag.Ret = ret;
            return View(photo);
        }

        // POST: Photos/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id, int ret = 0)
        {
            Photo photo = db.Photos.Find(id);
            db.Photos.Remove(photo);
            db.SaveChanges();
            return ret == 0
                    ? RedirectToAction("Index")
                    : RedirectToAction("Details", "Albums", new { id = ret })
                    ;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Views/Photos/Create.cshtml
@model TooJaVile.Models.Photo

@{
    ViewBag.Title = "Create";
}
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#datafile').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
        $(document).ready(function () {
            $("#file").change(function () {
                readURL(this);
            });
        });
    </script>
}


<h2>Lisa uus pilt</h2>


@using (Html.BeginForm("Create", "Photos", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    <input type="hidden" name="ret" value="@ViewBag.Ret" />

    <div class="form-horizontal">
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.AlbumId, "Vali album", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @if (ViewBag.Ret == 0)
                {
                    @Html.DropDownList("AlbumId", null, "-- Vali album --", htmlAttributes: new { @class = "form-control" })
                    @Html.ValidationMessageFor(model => model.AlbumId, "", new { @class = "text-danger" })
                }
                else
                {
                    @Html.DropDownList("AlbumId", null, htmlAttributes: new { @class = "form-control", disabled = "disabled" })
                    @Html.ValidationMessageFor(model => model.AlbumId, "", new { @class = "text-danger" })
                    @Html.HiddenFor(x => x.AlbumId)
                }
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PictureId, "Lisa pilt", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.HiddenFor(x => x.PictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
                <input type="file" name="file" id="file" />
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Created, "Loodud", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Lisa" class="btn btn-default" />
            </div>
        </div>
    </div>
}

@*TODO: kui lisad uue pildi, siis peaks tagasi saatma õige albumi vaatesse*@ 
@*@using (Html.BeginForm("Details", "Albums", new { id = ViewBag.Ret }, null))
{

    @Html.AntiForgeryToken()
    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Create" class="btn btn-default" />
        </div>
    </div>

}*@



@if (ViewBag.Ret == 0)
{
    <div>
        @Html.ActionLink("Tagasi nimekirja", "Index")
    </div>
}
else
{
    <div>
        @Html.ActionLink("Tagasi albumi nimekirja", "Details", "Albums", new { id = ViewBag.Ret }, null)
    </div>
}

Views/Photos/Delete.cshtml
@model TooJaVile.Models.Photo

@{
    ViewBag.Title = "Delete";
}

<h2>Kustuta pilt</h2>

<h3>Kas oled kindel, et soovid kustutada?</h3>
<div>
   <p> <img src="@Url.Action("Content", "DataFiles", new {id = Model.PictureId})" height="200" />   </p> 
    <p> Loodud @Html.DisplayFor(model => model.Created) </p>
        
       

    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Kustuta" class="btn btn-default" /> |
            @Html.ActionLink("Tagasi albumisse", "Index")
        </div>
    }
</div>

Views/Photos/Details.cshtml
@model TooJaVile.Models.Photo

@{
    ViewBag.Title = "Details";
}


<br />

<h2>Pilt</h2>

<div>
    <p> <img src="@Url.Action("Content", "DataFiles", new {id = Model.PictureId})" height="200" />   </p>
    <p> Loodud @Html.DisplayFor(model => model.Created) </p>

</div>
<p>
    @Html.ActionLink("Tagasi albumisse", "Index")
</p>

Views/Photos/Edit.cshtml
@model TooJaVile.Models.Photo

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm("Edit", "Photos", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">
    <h4>Photo</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.HiddenFor(model => model.Id)

    <div class="form-group">
        @Html.LabelFor(model => model.AlbumId, "AlbumId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("AlbumId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.AlbumId, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
        @Html.LabelFor(model => model.PictureId, "PictureId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("PictureId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
        </div>
    </div>*@

    <div class="form-group">
        @Html.LabelFor(model => model.Created, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
            @Html.LabelFor(model => model.PictureId, "Lisa pilt", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.HiddenFor(x => x.PictureId) //kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.
                <input type="file" name="file" id="file" />
                <p></p>
                <img src="@Url.Action("Content", "My", new { id=Model.PictureId })" height="120" id="datafile" />
            </div>
        </div>
        @Html.HiddenFor(x => x.PictureId)*@
    <div class="form-group">
        @Html.LabelFor(model => model.PictureId, "Lisa pilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.HiddenFor(x => x.PictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
            <input type="file" name="file" id="file" />
            <p></p>
            <img src="@Url.Action("Content", "My", new { id=Model.PictureId})" height="120" id="datafile" />
        </div>
    </div>
    @Html.HiddenFor(x => x.PictureId)


    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Save" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

<script>
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#datafile').attr('src', e.target.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }
    $(document).ready(function () {
        $("#file").change(function () {
            readURL(this);
        });
    });</script>

Views/Photos/Index.cshtml
@model IEnumerable<TooJaVile.Models.Photo>

@{
    ViewBag.Title = "Index";
}

<style>
    * {
        box-sizing: border-box;
    }

    body {
        margin: 0;
        font-family: Arial;
    }

    .body-content {
        padding-left: 0px;
        padding-right: 15px;
    }

    .header {
        text-align: center;
        padding: 32px;
    }

    .row {
        display: -ms-flexbox; /* IE10 */
        display: flex;
        -ms-flex-wrap: wrap; /* IE10 */
        flex-wrap: wrap;
        padding: 0 4px;
    }
    .pilt:hover {
        transition: transform .2s; /* Animation */
        width: 500px;
    }

    /* Responsive layout - makes a two column-layout instead of four columns */
    @@media screen and (max-width: 800px) {
        .column {
            -ms-flex: 50%;
            flex: 50%;
            max-width: 50%;
        }
    }

    /* Responsive layout - makes the two columns stack on top of each other instead of next to each other */
    @@media screen and (max-width: 600px) {
        .column {
            -ms-flex: 100%;
            flex: 100%;
            max-width: 100%;
        }
    }
</style>

<p>
    @Html.ActionLink("Lisa uus pilt", "Create")
</p>

<div style="display:flex; flex-wrap:wrap">
    @foreach (var item in Model)
    {
        <div class="gallery pilt">
            <div>
                <img src="@Url.Action("Content", "DataFiles", new {id = item.PictureId})" alt="Cover Picture">
                <div style="text-align:center; background-color: antiquewhite; padding:2px"> @Html.ActionLink("Kustuta", "Delete", new { id = item.Id })</div>
            </div>
        </div>
    }
</div>